import mx.utils.Delegate;
import mx.transitions.Tween;
import mx.transitions.easing.*;

/* Calender Popup for flash 8
 * Release: v0.3 - 07/18/2007
 * Author: Jim Palmer - jimpalmer@gmail.com - www.overset.com 
 * License: BSD License 
 * */

class Cal extends MovieClip {

	private var __cellsize:Number = 17;
	private var _dWidth:Number = 100;
	private var _dHeight:Number = 100;
	private var controlClip:MovieClip;
	private var pickMonth:MovieClip;
	private var rootClip:MovieClip;
	private var _dayCells:Array;

	private var __selectedDate:Date;
	private var __selectedCell;
	
	private var _days:Array = ["S", "M", "T", "W", "T", "F", "S"];
	private var _months:Array = ["JAN", "FEB", "MAR", "APR", "MAY", "JUN", "JUL", "AUG", "SEP", "OCT", "NOV", "DEC"];

	private var __preCellColor:Number = 0x808080;
	private var __preCellBg:Number = 0xFFFFFF;
	private var __preCellBorderHi:Number = 0xE3E3E3;
	private var __preCellBorderLo:Number = 0xE3E3E3;

	private var __cellColor:Number = 0x000000;
	private var __cellBg:Number = 0xE3E3E3;
	private var __cellBorderHi:Number = 0xCCCCCC;
	private var __cellBorderLo:Number = 0xCCCCCC;

	private var __apreCellColor:Number = 0x808080;
	private var __apreCellBg:Number = 0xFFFFFF;
	private var __apreCellBorderHi:Number = 0xE3E3E3;
	private var __apreCellBorderLo:Number = 0xE3E3E3;
	
	private var __hilightCellBg:Number = 0xEEEEEE;
	private var __hilightCellHi:Number = 0x808080;
	private var __hilightCellLo:Number = 0x808080;
	private var __growScale:Number = 0.4;
	
	private var __selectCellColor:Number = 0xFF9900;
	private var __selectCellBg:Number = 0xEEEEEE;
	private var __selectCellHi:Number = 0x000000;
	private var __selectCellLo:Number = 0x000000;
	
	private var __bg:Number = 0xFFFFFF;
	private var __bgHi:Number = 0x808080;
	private var __bgLo:Number = 0x808080;
	
	private var __padding:Number = 5;
	private var __visible:Boolean = false;
	
	private var __callbackFunc:String = "calCallback";
	
	private var __MouseHandler:Object = new Object();
	
	public var catchMon:Number;
	public var catchYear:Number;

	function Cal () {
		this._lockroot = false;
		
		if (typeof _root.observer == "undefined") {
			//trace("WARNING: observer pattern not found - make sure you instantiate the Observer.as as observer");
		} else {
			_root.observer.addSubscriber(this);
		}
		
		// set default month
		var currDate:Date = new Date();
		this.catchMon = currDate.getMonth();
		this.catchYear = currDate.getFullYear();
		delete(currDate);
		
		this._visible = this.__visible;
		
		this.onLoad = Delegate.create(this, drawCal);
	}
	
	function prevMonth ():Void {
		// set the previous month/year - and watch for negative value
		if (this.catchMon == 0) {
			this.catchYear--;
			this.catchMon = 11;
		} else {
			this.catchMon--;
		}
	}

	function nextMonth ():Void {
		// set the next month/year - and watch for rolling to the next year
		if (this.catchMon == 11) {
			this.catchYear++;
			this.catchMon = 0;
		} else {
			this.catchMon++;
		}
	}
	
	function drawCal ():Void {
		
		this.onLoad = null;
		
		var currDate:Date = new Date();
		//var currDate:Date = __selectedDate;
		currDate.setYear(this.catchYear);
		currDate.setMonth(this.catchMon);
		// zero out the time portion of the date
		currDate.setHours(0);
		currDate.setMinutes(0);
		currDate.setSeconds(0);
		currDate.setMilliseconds(0);
		var currMon:Date = new Date();
		currMon.setTime(currDate.getTime());
		// start at Day 1
		currMon.setDate(1);
		var prevMon:Date = new Date();
		prevMon.setTime(currDate.getTime());
		// set the previous month - and watch for negative value
		prevMon.setMonth((currMon.getMonth() == 0) ? 11 : (currMon.getMonth() - 1));
		// check prevmonth year
		if ((currMon.getMonth() == 0)) {
			prevMon.setYear(currMon.getFullYear() - 1);
		}
		
		this.clear();
		
		this.controlClip.removeMovieClip();
		this.controlClip = this.createEmptyMovieClip("controlClip", this.getNextHighestDepth());
		this.controlClip._x = Math.round(this.__padding);
		this.controlClip._y = Math.round(this.__padding);
		this.controlClip.attachMovie("Btn", "prevMon", this.controlClip.getNextHighestDepth(), {_x:0, _y:0}).init(12, 12, "<");
		this.controlClip.prevMon.onRelease = function () {
			this._parent._parent.prevMonth();
			this._parent._parent.drawCal();
		}
		
		var dateStrFormat:TextFormat = new TextFormat();
		dateStrFormat.font = "uni 05_53";
//		dateStrFormat.font = "Arial";
		dateStrFormat.size = 8;
		
		// month control
		this.controlClip.controlMonth = this.controlClip.createEmptyMovieClip("controlMonth", this.controlClip.getNextHighestDepth());
		this.controlClip.controlMonth._x = 16;
		this.controlClip.controlMonth.createTextField("dateMonth", this.controlClip.controlMonth.getNextHighestDepth(), 0, 0, ((this.__cellsize * 7) - (12 * 2) - 2), 16);
		var dTxt = this.controlClip.controlMonth["dateMonth"];
		dTxt.html = false;
		dTxt.embedFonts = true;
		dTxt.border = false;
		dTxt.type = "dynamic";
		dTxt.multiline = false;
		dTxt.mouseWheelEnabled = false;
		dTxt.background = false;
		dTxt.selectable = false;
		dTxt.wordWrap = false;
		dTxt.setTextFormat(dateStrFormat);
		dTxt.setNewTextFormat(dateStrFormat);
		dTxt.text = this._months[currDate.getMonth()];
		dTxt._width = dTxt.textWidth + 4;
		dTxt._height = dTxt.textHeight + 4;

		// hilight the mini pulldown
		this.controlClip.controlMonth.__hilightCellBg = this.__hilightCellBg;
		this.controlClip.controlMonth.onRollOver = function () {
			_root.drawBorder(this, 0, 0, this.dateMonth._width, this.dateMonth._height, this.__hilightCellBg, this.__hilightCellBg, this.__hilightCellBg);
		}
		this.controlClip.controlMonth.onRollOut = function () {
			this.clear();
		}
		this.controlClip.controlMonth.onRelease = function () {
			// make the month picker visible
			this._parent._parent.pickMonth._visible = true;
			// make sure the picker is on "top"
			this._parent._parent.pickMonth.swapDepths(this._parent._parent.getNextHighestDepth());
		}
		
		// draw months pulldown
		this.pickMonth.removeMovieClip();
		this.pickMonth = this.createEmptyMovieClip("pickMonth", this.controlClip.getNextHighestDepth());
		this.pickMonth._visible = false;
		this.pickMonth._x = (this.controlClip._x + this.controlClip.controlMonth._x);
//		this.pickMonth._y = (this.controlClip._y + this.controlClip.controlMonth._y + this.controlClip.controlMonth._height);
		this.pickMonth._y = (this.controlClip._y + this.controlClip.controlMonth._y);
		// controlling array of movieclips for each month
		this.pickMonth.months = new Array();
		for (var moCnt:Number = 0; moCnt < this._months.length; moCnt++) {
			this.pickMonth.months[moCnt] = this.pickMonth.createEmptyMovieClip("pickMonth_" + moCnt, this.pickMonth.getNextHighestDepth());
			this.pickMonth.months[moCnt]._y = Math.round(moCnt * 10);
			this.pickMonth.months[moCnt].createTextField("monthTxt", this.pickMonth.months[moCnt].getNextHighestDepth(), 0, 0, ((this.__cellsize * 7) - (12 * 2) - 2), 10);
			var dTxt = this.pickMonth.months[moCnt]["monthTxt"];
			dTxt.html = false;
			dTxt.embedFonts = true;
			dTxt.border = false;
			dTxt.type = "dynamic";
			dTxt.multiline = false;
			dTxt.mouseWheelEnabled = false;
			dTxt.background = false;
			dTxt.selectable = false;
			dTxt.wordWrap = false;
			dTxt.setTextFormat(dateStrFormat);
			dTxt.setNewTextFormat(dateStrFormat);
			dTxt.text = this._months[moCnt];
			dTxt._width = dTxt.textWidth + 4;
			//dTxt._height = 10;
			dTxt._y -= 2;
			// hilight the current month
			if (moCnt == this.catchMon) {
				_root.drawBorder(this.pickMonth.months[moCnt], 1, 1, this.pickMonth._width - 2, 9, this.__hilightCellBg, this.__hilightCellBg, this.__hilightCellBg);
			}
			// hilight the mini pulldown
			this.pickMonth.months[moCnt].__hilightCellBg = this.__hilightCellBg;
			this.pickMonth.months[moCnt].catchMon = moCnt;
			this.pickMonth.months[moCnt].onRollOver = function () {
				// only for non-current month
				if (this.catchMon != this._parent._parent.catchMon)
					_root.drawBorder(this, 1, 1, this._parent._width - 3, 10, this.__hilightCellBg, this.__hilightCellBg, this.__hilightCellBg);
			}
			this.pickMonth.months[moCnt].onRollOut = function () {
				// only for non-current month
				if (this.catchMon != this._parent._parent.catchMon)
					this.clear();
			}
			this.pickMonth.months[moCnt].onRelease = function () {
				this._parent._visible = false;
				this._parent._parent.catchMon = this.catchMon;
				this._parent._parent.drawCal();
			}
		}
		// draw a background+border for the month pulldown
		_root.drawBorder(this.pickMonth, 0, 0, this.pickMonth._width, this.pickMonth._height + 2, this.__bgHi, this.__bgLo, this.__bg);
		
		// year control
		this.controlClip.controlYear = this.controlClip.createEmptyMovieClip("controlYear", this.controlClip.getNextHighestDepth());
		this.controlClip.controlYear._x = ((this.__cellsize * 7) - 14);
		this.controlClip.controlYear.createTextField("dateYear", this.controlClip.controlYear.getNextHighestDepth(), 0, 0, 10, 16);
		var dTxt = this.controlClip.controlYear["dateYear"];
		dTxt.html = false;
		dTxt.embedFonts = true;
		dTxt.border = false;
		dTxt.type = "dynamic";
		dTxt.multiline = false;
		dTxt.mouseWheelEnabled = false;
		dTxt.background = false;
		dTxt.selectable = false;
		dTxt.wordWrap = false;
		dTxt.setTextFormat(dateStrFormat);
		dTxt.setNewTextFormat(dateStrFormat);
		dTxt.text = currDate.getFullYear().toString();
		dTxt._width = dTxt.textWidth + 4;
		dTxt._x -= dTxt.textWidth + 4;
		
		this.controlClip.attachMovie("Btn", "nextMon", this.controlClip.getNextHighestDepth(), {_x:((this.__cellsize * 7) - 12), _y:0}).init(12, 12, ">");
		this.controlClip.nextMon.onRelease = function () {
			this._parent._parent.nextMonth();
			this._parent._parent.drawCal();
		}
		
		// now draw the day labels
		for (var lCount:Number = 0; lCount < 7; lCount++) {
			this.controlClip.createTextField("label_"+lCount, this.controlClip.getNextHighestDepth(), (lCount * this.__cellsize), 14, 12, 16);
			var dTxt = this.controlClip["label_"+lCount];
			dTxt.html = false;
			dTxt.embedFonts = true;
			dTxt.border = false;
			dTxt.type = "dynamic";
			dTxt.multiline = false;
			dTxt.mouseWheelEnabled = false;
			dTxt.background = false;
			dTxt.selectable = false;
			dTxt.wordWrap = false;
			dTxt.text = this._days[lCount];
			dateStrFormat.color = 0x808080;
			dTxt.setTextFormat(dateStrFormat);
			dTxt.setNewTextFormat(dateStrFormat);
			dTxt._x += Math.round((14 - dTxt.textWidth) / 2);
		}
		
		var dayTally:Number = 0;
		var currTally:Number = 0;
		var nextMo:Boolean = false;
		var nextTally:Number = 0;
		var bgColor = this.__cellBg;
		var cellColor = this.__cellColor;
		var cellHi = this.__cellBorderHi;
		var cellLo = this.__cellBorderLo;
		
		this.rootClip.removeMovieClip();
		this.rootClip = this.createEmptyMovieClip("rootClip", this.getNextHighestDepth());
		this.rootClip._y = Math.round(this.controlClip._height + this.__padding);
		this.rootClip._x = Math.round(this.__padding);
		
		this._dayCells = new Array();
		
		// figure out previous month's maximum number of days
		var prevMonMaxDays:Number;
		for (var maxPM:Number = 28; prevMon.getMonth() != currMon.getMonth(); maxPM++) {
			prevMonMaxDays = (maxPM - 1);
			prevMon.setDate(maxPM);
		}
		
		for (var weekCount:Number = 0; (weekCount < 6 && nextMo == false); weekCount++) {
			for (var dayCount:Number = 0; dayCount < 7; dayCount++) {
				this._dayCells[dayTally] = this.rootClip.createEmptyMovieClip("dayCell_" + dayTally, this.rootClip.getNextHighestDepth());
				this._dayCells[dayTally]._y = (weekCount * this.__cellsize);
				this._dayCells[dayTally]._x = (dayCount * this.__cellsize);
				
				// init the date that'll be passed through
				var passthruDate:Date = new Date();
				passthruDate.setTime(currDate.getTime());
				var displayDay = "";
				
				// The logic below arranges the grid layout of the S to S weekly calander with previous/trailing months dates
				if (weekCount == 0 && dayCount < currMon.getDay()) {
					displayDay = (prevMonMaxDays - (currMon.getDay() - dayCount) + 1);
					bgColor = this.__preCellBg;
					cellColor = this.__preCellColor;
					cellHi = this.__preCellBorderHi;
					cellLo = this.__preCellBorderLo;
					if (passthruDate.getMonth() == 0) {
						passthruDate.setMonth(11);
						passthruDate.setYear((passthruDate.getFullYear() - 1));
					} else {
						passthruDate.setMonth((passthruDate.getMonth() - 1));
					}
					passthruDate.setDate(displayDay);
				} else if (weekCount == 0 && dayCount == currMon.getDay() && currTally == 0) {
					displayDay = currTally = 1;
					bgColor = this.__cellBg;
					cellColor = this.__cellColor;
					cellHi = this.__cellBorderHi;
					cellLo = this.__cellBorderLo;
					passthruDate.setDate(displayDay);
				} else if (currTally != 0 && currMon.getMonth() == currDate.getMonth()) {
					currTally++;
					displayDay = currTally;
					currMon.setDate(currTally + 1);
					bgColor = this.__cellBg;
					cellColor = this.__cellColor;
					cellHi = this.__cellBorderHi;
					cellLo = this.__cellBorderLo;
					passthruDate.setDate(displayDay);
				} else {
					nextMo = true;
					nextTally++;
					displayDay = nextTally;
					bgColor = this.__apreCellBg;
					cellColor = this.__apreCellColor;
					cellHi = this.__apreCellBorderHi;
					cellLo = this.__apreCellBorderLo;
					if (passthruDate.getMonth() == 11) {
						passthruDate.setMonth(0);
						passthruDate.setYear((passthruDate.getFullYear() + 1));
					} else {
						passthruDate.setMonth((passthruDate.getMonth() + 1));
					}
					passthruDate.setDate(displayDay);
				}
				
				// figure out of this is the same day for this "day" cell
				if (passthruDate.getMonth() == this.__selectedDate.getMonth() &&
					passthruDate.getDate() == this.__selectedDate.getDate() &&
					passthruDate.getYear() == this.__selectedDate.getYear()) {
					cellColor = this.__selectCellColor;
					bgColor = this.__selectCellBg;
					cellHi = this.__selectCellHi;
					cellLo = this.__selectCellLo;
					// remember that this is the "cell" that is of the current selected day
					this.__selectedCell = this._dayCells[dayTally];
				}
				
				// draw the "day" cell
				this.drawCell("dayText", this._dayCells[dayTally], displayDay.toString(), cellColor);
				// draw this "day" cell's background as per if it's selected or not
				_root.drawBorder(this._dayCells[dayTally], 1, 1, this.__cellsize - 1, this.__cellsize - 1, cellHi, cellLo, bgColor);
				
				this._dayCells[dayTally].__origCellHi = cellHi;
				this._dayCells[dayTally].__origCellLo = cellLo;
				this._dayCells[dayTally].__cellHi = this.__hilightCellHi;
				this._dayCells[dayTally].__cellLo = this.__hilightCellLo;
				this._dayCells[dayTally].__bgColor = bgColor;
				this._dayCells[dayTally].__hilightCellBg = this.__hilightCellBg;
				this._dayCells[dayTally].__date = passthruDate;
				this._dayCells[dayTally].__callbackFunc = this[this.__callbackFunc];
				this._dayCells[dayTally].__xScale = this._dayCells[dayTally]._width * this.__growScale;
				this._dayCells[dayTally].__yScale = this._dayCells[dayTally]._height * this.__growScale;
				this._dayCells[dayTally].__height = this._dayCells[dayTally]._height;
				this._dayCells[dayTally].__width = this._dayCells[dayTally]._width;
				this._dayCells[dayTally].__x = this._dayCells[dayTally]._x;
				this._dayCells[dayTally].__y = this._dayCells[dayTally]._y;
				this._dayCells[dayTally].onRollOver = function () {
					_root.drawBorder(this, 1, 1, (this["dayText"]._width - 1), (this["dayText"]._height - 1), this.__cellHi, this.__cellLo, this.__hilightCellBg);
					this.__tweenPosX = new Tween(this, "_x", Regular.easeOut, this.__x, (this.__x - Math.round(this.__xScale / 2)), 0.05, true);
					this.__tweenPosY = new Tween(this, "_y", Regular.easeOut, this.__y, (this.__y - Math.round(this.__yScale / 2)), 0.05, true);
					this.__tweenScaleX = new Tween(this, "_width", Regular.easeOut, this.__width, (this.__width + this.__xScale), 0.05, true);
					this.__tweenScaleY = new Tween(this, "_height", Regular.easeOut, this.__height, (this.__height + this.__yScale), 0.05, true);
					this.swapDepths(this._parent.getNextHighestDepth());
				}
				this._dayCells[dayTally].onRollOut = function () {
					this.__tweenPosX.stop();
					this.__tweenPosY.stop();
					this.__tweenScaleX.stop();
					this.__tweenScaleY.stop();
					this._xscale = 100;
					this._yscale = 100;
					this._x = this.__x;
					this._y = this.__y;
					_root.drawBorder(this, 1, 1, (this["dayText"]._width - 1), (this["dayText"]._height - 1), this.__origCellHi, this.__origCellLo, this.__bgColor);
					// make sure the selected cell has the front
					this._parent._parent.__selectedCell.swapDepths(this._parent.getNextHighestDepth());
				}
				this._dayCells[dayTally].onReleaseOutside = this._dayCells[dayTally].onRollOut;
				this._dayCells[dayTally].onRelease = function () {
					//trace(this.__date.toString());
					this.__callbackFunc(this.__date);
					// set this date as the current date in the rootClip
					this._parent._parent.selectDate(this.__date);
				}
				dayTally++;
			}
		}		
		this._dayCells[dayTally] = this.rootClip.createEmptyMovieClip("dayCellBlank", this.rootClip.getNextHighestDepth());
		// ensure the selected "cell" is on top of all other day cells
		this.__selectedCell.swapDepths(this.rootClip.getNextHighestDepth());
		
		// draw outline border of whole calendar
		_root.drawBorder(this, 0, 0, (this._width + (this.__padding * 2)), (this._height + (this.__padding * 2)), this.__bgHi, this.__bgLo, this.__bg);
		
	}

	function drawCell (TFName:String, target:MovieClip, cellText:String, cellColor:Number) {
		target.createTextField(TFName, target.getNextHighestDepth(), 0, 0, this.__cellsize, this.__cellsize);
		var dTxt = target[TFName];
		dTxt.html = false;
		dTxt.embedFonts = true;
		dTxt.border = false;
		dTxt.type = "dynamic";
		dTxt.multiline = false;
		dTxt.mouseWheelEnabled = false;
		dTxt.background = false;
		dTxt.selectable = false;
		dTxt.wordWrap = false;
		
		var btnTxtFormat:TextFormat = new TextFormat();
		btnTxtFormat.font = "uni 05_53";
//		btnTxtFormat.font = "Tahoma";
		btnTxtFormat.size = 8;
		btnTxtFormat.color = cellColor;
		btnTxtFormat.align = "right";
		dTxt.setTextFormat(btnTxtFormat);
		dTxt.setNewTextFormat(btnTxtFormat);
		
		dTxt.text = cellText;
		// nudge the cell to the right of the parent clip.
		dTxt._x += (target._width - dTxt._width);
	}
	
	function _show () {
		
		this.__MouseHandler._parent = this;
		this.__MouseHandler.onMouseUp = function () {
			// close the month picker if visible
			if (this._parent.pickMonth._visible) {
				if (!this._parent.pickMonth.hitTest(_root._xmouse, _root._ymouse))
					this._parent.pickMonth._visible = false;
			} else {
				// close the window if it fails the hitTest on the popup window
				if (!this._parent.hitTest(_root._xmouse, _root._ymouse))
					this._parent._hide();
			}
		}
		Mouse.addListener(this.__MouseHandler);
		
		// redraw the cal
		this.drawCal();
		// set visibility
		this._visible = true;
		// automagically swap depths
		this.swapDepths(_root.getNextHighestDepth());
		// disable application functionality
		_root.observer.iToggle(false);
		// keep certain buttons on
		this.controlClip.nextMon._on();
		this.controlClip.prevMon._on();
	}
	
	function _hide () {
		this._visible = false;
		// clobber global mouse handler
		Mouse.removeListener(this.__MouseHandler);
		// re-enable application functionality
		_root.observer.iToggle(true);
	}
	
	function selectDate (newDate:Date) {
		this.__selectedDate = newDate;
		// make sure this date is "zeroed out"
		this.__selectedDate.setHours(0);
		this.__selectedDate.setMinutes(0);
		this.__selectedDate.setSeconds(0);
		this.__selectedDate.setMilliseconds(0);
		this.catchMon = this.__selectedDate.getMonth();
		this.catchYear = this.__selectedDate.getFullYear();
		this.drawCal();
	}
	
}