import mx.utils.Delegate;
import ToolTip;

/* Input Box to duplicate FireFox functionality
 * Release: v0.1 - 07/18/2007
 * Author: Jim Palmer - jimpalmer@gmail.com - www.overset.com 
 * License: BSD License 
 * */

class InputBox extends MovieClip {

	private var __width:Number = 60;
	private var __height:Number = 16;
	[Inspectable(name=" txt font", defaultValue="Tahoma", type=String)]
	private var __txtFont:String = "Tahoma";
	[Inspectable(name=" txt size", defaultValue=10, type=Number)]
	private var __txtSize:Number = 10;
	private var __txtColor:Number = 0x000000;
	[Inspectable(name=" restrict", defaultValue="", type=String)]
	private var __txtRestrict:String = "";
	[Inspectable(name=" password", defaultValue=false, type=Boolean)]
	private var __txtPassword:Boolean = false;
	[Inspectable(name=" max chars", defaultValue=255, type=Number)]
	private var __txtMaxChars:Number = 255;
	[Inspectable(name=" required", defaultValue=false, type=Boolean)]
	private var _required:Boolean = false;
	[Inspectable(name=" show required in OUT state", defaultValue=true, type=Boolean)]
	private var _showReqOut:Boolean = true;
	[Inspectable(name=" show OK state", defaultValue=false, type=Boolean)]
	private var _showOk:Boolean = false;

	private var _out_hiColor = 0x808080;
	private var _out_loColor = 0xCCCCCC;
	private var _out_bgColor = 0xFFFFFF;
	
	private var _on_hiColor = 0x808080;
	private var _on_loColor = 0xCCCCCC;
	private var _on_bgColor = 0xEEEEEE;
	
	private var _err_hiColor = 0xAA0000;
	private var _err_loColor = 0xFF0000;
	private var _err_bgColor = 0xFFE1E1;
	
	private var BoundingBox:MovieClip;
	private var _reqNotify:MovieClip;
	
	[Inspectable(name=" value", defaultValue="", type=String)]
	public var _value:String;

	[Inspectable(name=" txt color", defaultValue="0x000000", type=Color)]
	function set txtColor (selectedColor:Number):Void {
		this.__txtColor = selectedColor;
	}
	function get txtColor ():Number {
		return this.__txtColor;
	}

	function InputBox () {
		this.__width = this._width;
		//this.__height = this._height = this.__txtSize + 4;
		//this._height = this.__height;
		
		this.tabEnabled = true;
		// do not allow the yellow tab-hilight on this Btn:MovieClip
		this._focusrect = false;
		
		// now draw the inital/default off-state of the button
		this.onLoad = Delegate.create(this, init);
		
		if (typeof _root.observer == "undefined") {
			trace("WARNING: observer pattern not found - make sure you instantiate the Observer.as as observer");
		} else {
			_root.observer.addSubscriber(this);
		}
	}
	
	function init (newValue:String):Void {
		// remove the onload recursion
		this.onLoad = null;

		this.clear();
		// update the value shown to the user in the TextField - works with component and attachmovie
		if (newValue) {
			this._value = newValue;
		}
		
		this._xscale = 100;
		this._yscale = 100;
		
		this["input"].removeTextField();
		this.createTextField("input", this.getNextHighestDepth(), 0, 0, this.__width, this.__height);
		var BT = this["input"];
		
		BT.border = false;
		BT.type = "input";
		BT.html = false;
		BT.embedFonts = false;
		BT.multiline = false;
		BT.mouseWheelEnabled = false;
		BT.background = false;
		BT.selectable = true;
		BT.wordWrap = false;
		BT.restrict = this.__txtRestrict;
		BT.password = this.__txtPassword;
		BT.maxChars = this.__txtMaxChars;
		
		var btnTxtFormat:TextFormat = new TextFormat();
		btnTxtFormat.font = this.__txtFont;
		btnTxtFormat.size = this.__txtSize;
		btnTxtFormat.color = this.__txtColor;
		btnTxtFormat.align = "left";
		BT.setTextFormat(btnTxtFormat);
		BT.setNewTextFormat(btnTxtFormat);
		
		// write temporarily the glyphs that'll maximize the height of the textfield
		BT.text = "^g_p";
		// resize the TextField with the calculated textHeight plus the 4pixel padding on the bottom
		BT._height = BT.textHeight + 4;
		// set the text that should appear
		BT.text = this._value;
		
		// declare the default focus functions
		BT.onSetFocus = this.renderOver;
		BT.onKillFocus = function () {
			if (this._parent._required && !this._parent.checkRequired()) {
				this._parent.renderErr();
			} else {
				if (_showOk)
					this._parent.renderOk();
				else
					this._parent.renderOut();
			}
		};
		
		// create the required notification movieclip
		this._reqNotify = this.createEmptyMovieClip("_reqNotify", this.getNextHighestDepth());
		this._reqNotify.tabEnabled = false;
		// do not allow the yellow tab-hilight on this Btn:MovieClip
		this._reqNotify._focusrect = false;
		this._reqNotify.useHandCursor = false;
		this._reqNotify._x = (this["input"]._width + 2);
		
		this.renderOut();

	}
	
	function checkRequired ():Boolean {
		if (this["input"].text.length > 0)
			return true;
		else
			return false;
	}
		
	function renderOut ():Void {
		var targetClip:MovieClip;
		if (this instanceof InputBox)
			targetClip = this;
		else
			targetClip = this._parent;
			
		targetClip.clear();
		_root.drawBorder(targetClip, 0, 0, targetClip["input"]._width, targetClip["input"]._height, targetClip._out_hiColor, targetClip._out_loColor, targetClip._out_bgColor);

		if (targetClip._showReqOut) {
			targetClip.renderRequired(targetClip._reqNotify);
		} else {
			targetClip._reqNotify.clear();
			targetClip._reqNotify.textMsgStrShadow.removeTextField();
			targetClip._reqNotify.textMsgStr.removeTextField();
		}
	}

	function renderOk ():Void {
		var targetClip:MovieClip;
		if (this instanceof InputBox)
			targetClip = this;
		else
			targetClip = this._parent;
			
		targetClip.clear();
		_root.drawBorder(targetClip, 0, 0, targetClip["input"]._width, targetClip["input"]._height, targetClip._out_hiColor, targetClip._out_loColor, targetClip._out_bgColor);
		if (targetClip._showReqOut) {
			targetClip.renderRequiredOk(targetClip._reqNotify, "OK");
		} else {
			targetClip._reqNotify.clear();
			targetClip._reqNotify.textMsgStrShadow.removeTextField();
			targetClip._reqNotify.textMsgStr.removeTextField();
		}
	}

	function renderOver ():Void {
		if (this instanceof InputBox) {
			this.clear();
			this._reqNotify.clear();
			_root.drawBorder(this, 0, 0, this["input"]._width, this["input"]._height, this._on_hiColor, this._on_loColor, this._on_bgColor);
			this.renderRequired(this._reqNotify);
		} else {
			this._parent.clear();
			this._parent._reqNotify.clear();
			_root.drawBorder(this._parent, 0, 0, this._parent["input"]._width, this._parent["input"]._height, this._parent._on_hiColor, this._parent._on_loColor, this._parent._on_bgColor);
			this._parent.renderRequired(this._parent._reqNotify);
		}
	}

	function renderErr ():Void {
		if (this instanceof InputBox) {
			this.clear();
			this._reqNotify.clear();
			_root.drawBorder(this, 0, 0, this["input"]._width, this["input"]._height, this._err_hiColor, this._err_loColor, this._err_bgColor);
			this.renderRequiredErr(this._reqNotify, "REQUIRED");
		} else {
			this._parent.clear();
			this._parent._reqNotify.clear();
			_root.drawBorder(this._parent, 0, 0, this._parent["input"]._width, this._parent["input"]._height, this._parent._err_hiColor, this._parent._err_loColor, this._parent._err_bgColor);
			this._parent.renderRequiredErr(this._parent._reqNotify, "REQUIRED");
		}
	}

	function renderRequired (target:MovieClip):Void {
		if (target._parent._required) {
			//_root.drawRequired(target, (target._parent["input"]._width - 8), -8, 13, 13);
			target._parent.drawArrow(target, 9, 2.5, 0, 0xAAAAAA, 0xE3E3E3, 0, "REQUIRED");
		}
	}

	function renderRequiredErr (target:MovieClip, textMsg:String):Void {
		if (target._parent._required) {
			//_root.drawRequired(target, (target._parent["input"]._width - 8), -8, 13, 13);
			target._parent.drawArrow(target, 9, 2.5, 0, 0xAA0000, 0xFF0000, 0, textMsg);
		}
	}

	function renderRequiredOk (target:MovieClip, textMsg:String):Void {
		if (target._parent._required) {
			//_root.drawRequired(target, (target._parent["input"]._width - 8), -8, 13, 13);
			target._parent.drawArrow(target, 9, 2.5, 0, 0x00AA00, 0x00FF00, 0, textMsg);
		}
	}
	
	function reset ():Void {
		this["input"].text = "";
		this.renderOut();
	}
	
	function _off ():Void {
		this["input"].selectable = false;
		//this.renderOut();
	}

	function _on ():Void {
		this["input"].selectable = true;
		//this.renderOut();
	}

	function drawArrow (target:MovieClip, arrowSize:Number, startX:Number, startY:Number, strokeColor:Number, bgColor:Number, strokeThickness:Number, textMsg:String) {
		var regionHeight = target._parent["input"]._height;
		var topColors = [strokeColor, bgColor];
		var alphas = [100, 100];
		var ratios = [0, 255];
		// recenter the Y
		startY += Math.round((regionHeight / 2) - (arrowSize / 2));
		var topMatrix = {matrixType:"box", x:arrowSize/4, y:arrowSize/4, w:arrowSize*2, h:arrowSize*2, r:45/180*Math.PI};
		target.beginGradientFill("radial", topColors, alphas, ratios, topMatrix);	
		target.lineStyle(strokeThickness, strokeColor, 100);
		target.moveTo(startX, (startY + (arrowSize / 2)));
		target.lineTo((startX + arrowSize), startY);
		target.lineTo((startX + arrowSize), (startY + arrowSize));
		target.lineTo(startX, (startY + (arrowSize / 2)));
		target.endFill();
		
		var BSName:String = "textMsgStrShadow";
		var BTName:String = "textMsgStr";
		target.createTextField(BSName, target.getNextHighestDepth(), (arrowSize + 4), 0, 25, regionHeight);
		target.createTextField(BTName, target.getNextHighestDepth(), (arrowSize + 4), 0, 25, regionHeight);
		var BS = target[BSName];
		var BT = target[BTName];
			
		BT.text = BS.text = textMsg;
			
		BT.border = BS.border = false;
		BT.type = BS.type = "static";
		BT.html = BS.html = false;
		BT.embedFonts = BS.embedFonts = true;
		BT.multiline = BS.multiline = false;
		BT.mouseWheelEnabled = BS.mouseWheelEnabled = false;
		BT.background = BS.background = false;
		BT.selectable = BS.selectable = false;
		BT.wordWrap = BS.wordWrap = false;
			
		var btnTxtFormat:TextFormat = new TextFormat();
		btnTxtFormat.font = "uni 05_53";
		btnTxtFormat.size = 8;
		btnTxtFormat.color = 0xFFFFFF;
		BS.setTextFormat(btnTxtFormat);
		BS.setNewTextFormat(btnTxtFormat);
		btnTxtFormat.color = strokeColor;
		BT.setTextFormat(btnTxtFormat);
		BT.setNewTextFormat(btnTxtFormat);
			
		BT._width = BT.textWidth + 3;
		BT._y = Math.round( ((regionHeight / 2) - (btnTxtFormat.size)) );
			
		BS._alpha = 50;
		BS._x = BT._x + 1;
		BS._y = BT._y + 1;
	}

}