
/* Global Drawing Functionality
 * Release: v0.1 - 07/18/2007
 * Author: Jim Palmer - jimpalmer@gmail.com - www.overset.com 
 * License: BSD License */

_global.drawFillRect = function (target:MovieClip, x1, y1, width, height, borColor, filColor):Void {

	target.lineStyle(0, borColor);
	target.moveTo(x1+0.5, y1+0.5);
	target.beginFill(filColor);
	target.lineTo(x1+width-0.5, y1+0.5);
	target.lineTo(x1+width-0.5, y1+height-0.5);
	target.lineTo(x1+0.5, y1+height-0.5);
	target.lineTo(x1+0.5, y1+0.5);
	target.endFill();

}

_global.drawBorder = function (target:MovieClip, x1, y1, width, height, hiColor, loColor, bgColor):Void {

	var borderWidth:Number = 1;
	var borderCnt:Number = borderWidth / 2;
	target.lineStyle(0, hiColor, 100);
	target.moveTo((x1 - borderCnt), (y1 + height + borderCnt));
	target.beginFill(bgColor);
	target.lineTo((x1 - borderCnt), (y1 - borderCnt));
	target.lineTo((x1 + width + borderCnt), (y1 - borderCnt));
	target.lineStyle(0, loColor, 100);
	target.lineTo((x1 + width + borderCnt), (y1 + height + borderCnt));
	target.lineTo((x1 - borderCnt), (y1 + height + borderCnt));
	target.endFill();

}

_global.drawRequired = function (target:MovieClip, x, y, w, h) {
	/* function thanks to http://www.senocular.com/flash/actionscript.php?file=ActionScript_1.0/Functions/Drawing/circle.as */
	w /= 2; h /= 2;
	// center the circle
	x += w; y += h;
	var xc1 = w*(Math.SQRT2-1), xc2 = w*(Math.SQRT2/2);
	var yc1 = h*(Math.SQRT2-1), yc2 = h*(Math.SQRT2/2);

	var colors = [0xFF0000, 0xAA0000];
	var alphas = [100, 100];
	var ratios = [0, 255];
	var matrix = {matrixType:"box", x:x-(w), y:y-(h*2), w:w*2, h:h*2, r:Math.PI};
	var borderWidth:Number = 1;
	var borderCnt:Number = borderWidth / 2;
	target.lineStyle(0, 0xFFFFFF, 100);
	target.beginGradientFill("radial", colors, alphas, ratios, matrix);
	target.moveTo(x+w, y);
	target.curveTo(x+w, y+yc1, x+xc2, y+yc2);
	target.curveTo(x+xc1, y+h, x, y+h);
	target.curveTo(x-xc1, y+h, x-xc2, y+yc2);
	target.curveTo(x-w, y+yc1, x-w, y);
	target.curveTo(x-w, y-yc1, x-xc2, y-yc2);
	target.curveTo(x-xc1, y-h, x, y-h);
	target.curveTo(x+xc1, y-h, x+xc2, y-yc2);
	target.curveTo(x+w, y-yc1, x+w, y);
	target.endFill();

	target.createTextField("_reqBox", target.getNextHighestDepth(), x - (w/2+1), y - (h), 12, 12);
	var BT = target["_reqBox"];
	
	BT.border = false;
	BT.type = "static";
	BT.html = false;
	BT.embedFonts = false;
	BT.multiline = false;
	BT.mouseWheelEnabled = false;
	BT.background = false;
	BT.selectable = false;
	BT.wordWrap = false;
	
	var btnTxtFormat:TextFormat = new TextFormat();
	btnTxtFormat.font = "Tahoma";
	btnTxtFormat.size = 8;
	btnTxtFormat.bold = true;
	btnTxtFormat.color = 0xE3E3E3;
	BT.setTextFormat(btnTxtFormat);
	BT.setNewTextFormat(btnTxtFormat);
	BT.text = "R";
	
}

var drawFillRect = _global.drawFillRect;
var drawBorder = _global.drawBorder;
var drawRequired = _global.drawRequired;
